package extThopt;

import com.hummeling.if97.IF97;
import com.hummeling.if97.OutOfRangeException;

public class WaterIF97 extends extThopt.ExtSubstance implements Inversable {
	com.hummeling.if97.IF97 iF97= new com.hummeling.if97.IF97();
	public WaterIF97(){
		super();
	//	iF97= new com.hummeling.if97.IF97();
		iF97.setUnitSystem(com.hummeling.if97.IF97.UnitSystem.ENGINEERING);
	       type=getCompType();
	        M=18.015257;PC=220.64;TC=647.096; 
	        Tmini=273.14;  Tmaxi=1000; 
	        Pmini=0.001;  Pmaxi=1000;
	        chemForm="IAPWS-IF97 water";
	        typeCorps=6;//corps externe de type isMixture (non transmis)  	      
	}
/*    public String getSoftware(){
        return "IAPWS-IF97";
    }
*/
	
    public String getCompType(){
        return "WaterIF97";
    }
    public String getType(){
        return "WaterIF97";
    }
	public String getClassDescription(){
	    return "IAPWS-IF97 steam tables by R. Hammering\n\nauthor : R. Gicquel   2020";
	}
	

		//Mthodes de calcul gnrales pour les corps externes
	    
	    /**
	    * calcule l'tat complet du corps pour un mlange externe
	    * <p>
	    * calculates the substance state for an external mixture
		*<p>
		* must be overriden by external mixtures
	    * @param T double (temperature)
	    * @param P double (pressure)
	    * @param x double (quality)
	    * result[0]=calcH(T,p,x);
	        result[1]=calcV(T,p,x);
	        result[2]=calcCv(T,p,x);
	        result[3]=calcXx(T,p,x);
	        result[4]=calcU(T,p,x);
	        result[5]=calcS(T,p,x);

	    */
	    public double[] CalcPropCorps (double T, double P, double x) {
	        double[]result=new double[6];
	        double t=T-273.15;
//		       System.out.println("pass dans CalcPropCorps");
		       double Tsat=getSatTemperature(P, x);

		       if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
		        // Lance le Calcul
			        // Rcupre les rsultats
			        result[0]=iF97.specificEnthalpyPT(P,t);//calcH(T,p,x);
			        result[1]=1/iF97.densityPT(P,t); //calcV(T,p,x);
			        result[2]=iF97.isobaricHeatCapacityPT(P,t); //calcCv(T,p,x);
			        result[3]=x; //calcXx(T,p,x);
			        X[0]=x;//on renvoie le taux de vaporisation dans tous les cas dans X[0]	
			        result[4]=iF97.specificInternalEnergyPT(P,t); //calcU(T,p,x);
			        result[5]=iF97.specificEntropyPT(P,t); //calcS(T,p,x);
		
		        }
		        else{/* Charge le calcul  saturation ELV */	        
		//	       System.out.println("quilibre liquide / vapeur");
			        result[0]=iF97.specificEnthalpyPX(P,x);
			        result[1]=1/iF97.densityPX(P,x);		       
			        result[2]=iF97.isobaricHeatCapacityPH(P,result[0]); //calcCv(T,p,x);
			        result[3]=x; //calcXx(T,p,x);
			        X[0]=x;//on renvoie le taux de vaporisation dans tous les cas dans X[0]	
			        result[4]=iF97.specificInternalEnergyPH(P,result[0]);
			        result[5]=iF97.specificEntropyPX(P,x); //calcS(T,p,x);
		       }
				
	       return result;
	        
	    }
	      public void updateComp(String systType, double fractType, double[] fractmol){

	      }
	     
	    /**
	    * calcule la pression P, h et T tant donns
	    * <p>
	    * calculates the pressure P, h and T being known
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $hv double (enthalpy)
	    * @param $T double (temperature)
	    */
		public double getP_from_hT(double h,double T){
	        double t=T-273.15;
	        double min, max;
	//        OutOfRangeException e =new OutOfRangeException(IF97.Quantity.h, min,max);
//	     
	        double P=Util.dicho_T (this,h,t, "getP_from_hT",0.0001, 1000,0.00001);
			

			return P;
			}
		
	    public double f_dicho(double arg1, double arg2, String fonc){

	    	if (fonc.equals("getP_from_hT")){
	    		
	    		return iF97.specificEnthalpyPT(arg2,arg1);
	    	}
	    	else if (fonc.equals("getP_from_sT")){
	    		double s=iF97.specificEntropyPT(arg1,arg2);
	    		return s;
	    	}
	    	else if (fonc.equals("getP_from_sv")){
	    		double v=iF97.specificVolumePS(arg1,arg2);
	    		return v;
	    	}
	    	else if (fonc.equals("getT_from_uv")){
	    		//On fait un premier calcul  partir de u (arg2)
	    		//puis on passe  h en itrant 10 fois
	    		double v=iF97.specificVolumePH(arg1,arg2);
	    		for(int i=0;i<10;i++){
	    			 v=iF97.specificVolumePH(arg1,arg2+100*arg1*v);
	    		}
	    		return v;
	    	}
	    	
	    	else if (fonc.equals("getP_from_vT")){
	    		double v=iF97.specificVolumePT(arg1,arg2);
	    		return v;
	    	}

	        
	    	return 0;
	    }
	    /**
	    * calcule la temprature T, h et P tant donns
	    * <p>
	    * calculates the temperature T, h and P being known
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $hv double (enthalpy)
	    * @param $P double (pressure)
	    */
		public double getT_from_hP(double h,double P){
			double T= iF97.temperaturePH(P, h)+273.15;
			X[0]=iF97.vapourFractionPH(P, h);
			x=X[0];
			xx=x;
		    return T;

			}
	    /**
	    * calcule la pression P, s et T tant donns
	    * <p>
	    * calculates the pressure P, s and T being known
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $sv double (entropy)
	    * @param $T double (temperature)
	    */
		public double getP_from_sT(double s,double T){
		
			return getP_from_sT(s, T,0.0001, 1000);
			}
	    /**
	    * calcule la pression P, s et T tant donns
	    * <p>
	    * calculates the pressure P, s and T being known
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param s double (entropy)
	    * @param T double (temperature)
	    * @param pmin double (minimum pressure)
	    * @param pmax double (maximum pressure)
	    */
		public double getP_from_sT(double s,double T, double pmin, double pmax){
	        double t=T-273.15;
	        double P=Util.dicho_T (this,s,t, "getP_from_sT",0.0001, 1000,1e-8);
			X[0]=iF97.vapourFractionTS(t, s);			
			return P;
		}
	  
	    /**
	    * calcule la temprature T, s et P tant donns
	    * <p>
	    * calculates the temperature T, s and P being known
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $sv double (entropy)
	    * @param $P double (pressure)
	    */
		public double getT_from_sP(double s,double P){
			double T=iF97.temperaturePS(P,s)+273.15;
			X[0]=iF97.vapourFractionPS(P, s);
		    return T;
		}

	    /**
	    * calcule la temprature T, s et v tant donns
	    * <p>
	    * calculates the temperature T, s and v being known
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $sv double (entropy)
	    * @param $v double (volume)
	    */
		public double getT_from_sv(double s,double v){
	        double P=Util.dicho_T (this,v,s, "getP_from_sv",0.007, 220,1e-10);
 //   		System.out.println(" sv inv "+v+" s "+s+" P "+P);
 	        X[0]=iF97.vapourFractionPS(P, s);
		    return iF97.temperaturePS(P, s)+273.15;
		}
	    
	    /**
	    * calcule la temprature T, u et v tant donns
	    * <p>
	    * calculates the temperature T, u and v being known
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $u double (internal energy)
	    * @param $v double (volume)
	    */
		public double getT_from_uv(double u,double v){
			
	        double P=Util.dicho_T (this,v,u, "getT_from_uv",0.007, 220,1e-10);
     		double h=u+100.*P*v;
	        X[0]=iF97.vapourFractionPH(P, h);
		    return iF97.temperaturePH(P, h)+273.15;
		}
	    
	    /**
	    * calcule la pression P, v et T tant donns
	    * <p>
	    * calculates the pressure P, v and T being known
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $v double (volume)
	    * @param $T double (temperature)
	    */
		public double getP_from_vT(double v,double T){
		        double t=T-273.15;
				double vl,vv, P=0;
				double Psat=getSatPressure(T,x);
//			    System.out.println(" v getP_from_vT "+v+" Psat "+Psat+" t "+t);
		        vl=iF97.specificVolumePX(Psat, 0);
		        vv=iF97.specificVolumePX(Psat, 1);
	    	   if(v<vl){
	    		   X[0]=0;
	    		   P=Util.dicho_T (this,v,t, "getP_from_vT",Psat, 1000,1e-10);
	    	   }
	    	   else if(v>vv){
	    		   X[0]=1;
	    		   P=Util.dicho_T (this,v, t, "getP_from_vT",0.001, Psat,1e-9);
	    	   }
	    	   else{/* Charge le calcul  saturation ELV */
		        	X[0]=(v-vl)/(vv-vl);	    		   
	    	   }
//		       System.out.println(" P 2 "+P+" x "+X[0]);

		    return P;
		}
	    /**
	    * calcule P, T et x, s et h tant donns
	    * <p>
	    * calculates P, T and x, s et h being known
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $v double (volume)
	    * @param $T double (temperature)
	    */
	    public double[] getPTx_from_sh(double s, double h){
	        double[]val=new double[3];
		       val[0]=iF97.pressureHS(h, s);//P
		       val[1]=iF97.temperatureHS(h, s);//T
		       val[2]=iF97.vapourFractionPH(val[0], h);//x
	        
	        return val;
	    }


	    /**
	    * calcule la pression de saturation
	    * <p>
	    * calculates the saturation pressure
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    * @param x double (quality)
	    */
		public double getSatPressure(double T, double x){
	        double t=T-273.15;
//		       System.out.println("T "+t+"  x "+x);
			
		    return iF97.saturationPressureT(t);
		}
		
		

	    /**
	    * calcule la temprature de saturation
	    * <p>
	    * calculates the saturation temperature
		* <p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param P double (pressure)
	    * @param x double (quality)
	    */
		public double getSatTemperature(double P, double x){
	    return iF97.saturationTemperatureP(P)+273.15;
		}
	    
	    /**
	    * calcule l'enthalpie
	    * <p>
	    * calculates the enthalpy
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    */
		public double calcH (double T, double P,double x) {
			double h=0;
		       double Tsat=getSatTemperature(P, x);
		        double t=T-273.15;
//			       Systeintln("pass dans calcH");

//			       System.out.println("Tsat "+Tsat+"  x "+x);
		       if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
			        h=iF97.specificEnthalpyPT(P,t);//calcH(T,p,x);
		
		        }
		        else{/* Charge le calcul  saturation ELV */	        
			        h=iF97.specificEnthalpyPX(P,x);
		       }
		
				return h;
			}
		public double calcU (double T, double P,double x) {
			
//			return calcH(T,  P, x)-iF97.R/IF97.M*T;
			return calcH(T,  P, x)-P*100*iF97.specificVolumePT(P,T-273.15);
			}


	    /**
	    * calcule la capacit thermique massique  volume constant
	    * <p>
	    * calculates the constant volume mass thermal capacity
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    */
		public double calcCv (double T, double P,double x) {
			double Cv=0;
		       double Tsat=getSatTemperature(P, x);
		       double t=T-273.15;
	//		       Systeintln("pass dans calcCv");
		       if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
		    	   Cv=iF97.isochoricHeatCapacityPT(P,t);//calcH(T,p,x);
		        }
		        else{/* Charge le calcul  saturation ELV */	
		        	double h=iF97.specificEnthalpyPX(P,x);
		        	Cv=iF97.isochoricHeatCapacityPH(P,h);
		       }		
				return Cv;
			}

	    /**
	    * calcule la capacit thermique massique  pression constante
	    * <p>
	    * calculates the constant pressure mass thermal capacity
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    */
		public double calcCp (double T, double P,double x) {
			double Cp=0;
		       double Tsat=getSatTemperature(P, x);
		       double t=T-273.15;
		       if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
		    	   Cp=iF97.isobaricHeatCapacityPT(P,t);//calcH(T,p,x);
		        }
		        else{/* Charge le calcul  saturation ELV */	
		        	double h=iF97.specificEnthalpyPX(P,x);
		        	Cp=iF97.isobaricHeatCapacityPH(P,h);
		       }		
				return Cp;
		}
		
	    /**
	    * calcule Cp
	    * <p>
	    * calculates Cp
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param Cv double (constant volume mass thermal capacity)
	    */
	    public double getCp(double Cv) {
	        return Cv;
	    }

	    /**
	    * calcule le volume
	    * <p>
	    * calculates the volume
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    */
		public double calcV (double T, double P,double x) {
			double v=0;
		       double Tsat=getSatTemperature(P, x);
		        double t=T-273.15;
			    if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
		    	   v=1/iF97.densityPT(P,t);//calcH(T,p,x);
		        }
		        else{/* Charge le calcul  saturation ELV */	
		        	v=1/iF97.densityPX(P,x);
		       }		
				return v;
			}
	  
	    /**
	    * calcule l'entropie
	    * <p>
	    * calculates the entropy
		*<p>
		* to be overriden ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    */
		public double calcS (double T, double P,double x) {
			double s=0;
		       double Tsat=getSatTemperature(P, x);
		        double t=T-273.15;
		       if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
			        s=iF97.specificEntropyPT(P,t);//calcH(T,p,x);
		        }
		        else{/* Charge le calcul  saturation ELV */	        
			        s=iF97.specificEntropyPX(P,x);
		       }		
				return s;
			}
	  
	    /**
	    * calcule le titre
	    * <p>
	    * calculates the quality
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param T double (temperature)
	    */
		public double calcXx (double T, double P,double x) {
	       double t=T-273.15;
		   double Tsat=getSatTemperature(P, x);
	       if(Math.abs(T-Tsat)>0.001){//Charge le calcul Hors ELV
		        double  h=iF97.specificEnthalpyPT(P,t);
		        x=iF97.vapourFractionPH(P, h);
		    }
	        X[0]=x;
			xx=X[0];
			return X[0];
		}
	  
	    /**
	    * cette mthode calcule la viscosit dynamique liquide en Pa.s
		*<p>
		* to be overriden by ExtSubstance subclasses
	    * @return double
	    * @param $T double (temprature)
	    */
	    /**
		    * cette mthode calcule la viscosit dynamique liquide en Pa.s
			*<p>
			* to be overriden by ExtSubstance subclasses
		    * @return double
		    * @param $T double (temprature)
		    */
		    public double getLiquidViscosity(double T) {
		        double t=T-273.15;
		    	return iF97.dynamicViscosityPT(100,t);
		    }
		    public double getLiquidViscosity(double T, double P) {
		        double t=T-273.15;
		        return iF97.dynamicViscosityPT(P,t);
		    }

		    /**
		    * cette mthode calcule la viscosit dynamique vapeur en Pa.s
		 	*<p>
			* to be overriden by ExtSubstance subclasses
		   * @return double
		    * @param $T double (temprature)
		    */
		    public double getVaporViscosity(double T) {
		        double t=T-273.15;
		    	return iF97.dynamicViscosityPT(0.001,t);
//		    	return iF97.dynamicViscosityPT(100,t);
		    }
		    public double getVaporViscosity(double T, double P) {
		        double t=T-273.15;
		        return iF97.dynamicViscosityPT(P,t);
		    }

		    /**
		    * cette mthode calcule la conductivit thermique liquide en W/m/K
			*<p>
			* to be overriden by ExtSubstance subclasses
		    * @return double
		    * @param $T double (temprature)
		    */
		    public double getLiquidConductivity(double T) {
		        double t=T-273.15;
		    	return iF97.thermalConductivityPT(100,t)*1000.;
		    }
		    public double getLiquidConductivity(double T, double P) {
		        double t=T-273.15;
		        return iF97.thermalConductivityPT(P,t)*1000.;
		    }

		    /**
		    * cette mthode calcule la conductivit thermique vapeur en W/m/K
			*<p>
			* to be overriden by ExtSubstance subclasses
		    * @return double
		    * @param $T double (temprature)
		    */
		    public double getVaporConductivity(double T) {
		        double t=T-273.15;
//		    	return iF97.thermalConductivityPT(100,t)*1000.;
		    	return iF97.thermalConductivityPT(0.001,t)*1000.;
		    }  
		    public double getVaporConductivity(double T, double P) {
		        double t=T-273.15;
		        return iF97.thermalConductivityPT(P,t)*1000.;
		    }  
		    
			
		    public double[] getTransportProperties(double T, double rho){
		        double[]res={0,0,0};
		/*        double Psat=getSatPressure(T,1);
		        double[] resCalc=CalcPropCorps(T, Psat, 1);
		        double rhoSat=1/resCalc[1]/18.015257;
		        System.out.println("ExtSubts "+ " rho : "+rho+ " rho sat: "+rhoSat);
		        if(rho>rhoSat){

	//		    if(getQuality()[0]==0){
			        res[0]=getLiquidViscosity(T);
			        res[1]=getLiquidConductivity(T);
			    }
			    else{
			        res[0]=getVaporViscosity(T);
			        res[1]=getVaporConductivity(T);
			    }*/
		        double t=T-273.15;
		        res[0]=iF97.dynamicViscosityRhoT(rho*18.015257, t);
		        res[1]=iF97.thermalConductivityRhoT(rho*18.015257, t)*1000.;
		    	res[2]=getSurfaceTension(T);
		        return res;
		    }

	    
	    /**
	     * cette mthode renvoie les proprits critiques 
	 	*<p>
	 	* to be overriden in ExtSubstance mixture subclasses
	     * @return double[]
	     */
	   public double[] getCriticalParameters(){
		   // M=18.015257;PC=220.64;TC=647.096;
	        double[]res={647.096,220.64,0.0031055901,18.015257};
	    	return res;
	    }

	   public double getSurfaceTension(double T){
			double tau=1-T/647.096;
			double sigma=0.2358*Math.pow(tau, 1.256)*(1-0.625*tau);
			return sigma;
		}
	
	
	
	
	
	
	
	
	
	
}
